



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>面试问题4：C语言预处理包括哪些</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">面试问题4：C语言预处理包括哪些</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 05:36:19 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>问题描述：C语言 预处理包括哪些操作</strong></p>
<p>　　C语言的三种预处理包括：宏定义（#define）、文件包含(#include)、条件编译(#if、#else、#endif)。</p>
<p>对于宏定义的介绍：</p>
<p>　　宏定义必须写在函数外，其作用域为宏定义起到源程序结束。C语言源程序中允许用一个标识符来表示一个字符串，称为&ldquo;宏&rdquo;。被定义为宏的标识符称为&ldquo;宏名&rdquo;。在编译预处理时，对程序中所有出现的宏名，都用宏定义中的字符串去代换，这称为宏替换或宏展开。</p>
<p>　　无参宏的宏名后不带参数。其定义的一般形式为：&nbsp;#define &nbsp;标识符 &nbsp;字符串。&nbsp;其中，&ldquo;#&rdquo;表示这是一条预处理命令(以#开头的均为预处理命令)。&ldquo;define&rdquo;为宏定义命令。&ldquo;标识符&rdquo;为符号常量，即宏名。&ldquo;字符串&rdquo;可以是常数、表达式、格式串等。</p>
<div>
<div>　　C语言允许宏带有参数。在宏定义中的参数称为形式参数，在宏调用中的参数称为实际参数。</div>
<div>&nbsp; &nbsp; &nbsp;对带参数的宏，在调用中，不仅要宏展开，而且要用实参去代换形参。&nbsp;带参宏定义的一般形式为：&nbsp; #define &nbsp;宏名(形参表) &nbsp;字符串</div>
<div>　　举例说明：</p>
<div>　　#define INC(x) x+1 &nbsp;//宏定义</div>
<div>&nbsp;　　y = INC(5); &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; //宏调用</div>
<div>&nbsp; &nbsp; &nbsp;在宏调用时，用实参5去代替形参x，经预处理宏展开后的语句为y=5+1。</div>
<div>
<div>　　</div>
<div>带参宏注意事项：</div>
<div>（1）宏名和形参表的括号间不能有空格。</div>
<div>（2）宏替换只作替换，不做计算，不做表达式求解。</div>
<div>（3）函数调用在编译后程序运行时进行，并且分配内存。宏替换在编译前进行，不分配内存。</div>
<div>（4）宏展开不占用运行时间，只占编译时间，函数调用占运行时间(分配内存、保留现场、值传递、返回值)。</div>
<div>（5）为防止无限制递归展开，当宏调用自身时，不再继续展开。如：#define TEST(x) &nbsp;(x + TEST(x))被展开为1 + TEST(1)。</div>
<div>#include&lt;a.h&gt;和#include&ldquo; a.h&ldquo; 的区别：</div>
<div>使用尖括号表示在包含文件目录中去查找(包含目录是由用户在设置环境时设置的include目录)，而不在当前源文件目录去查找；</div>
<div>使用双引号则表示首先在当前源文件目录中查找，若未找到才到包含目录中去查找。用户编程时可根据自己文件所在的目录来选择某一种命令形式。</div>
<div>&nbsp;</div>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxem08y.html">mysql5&period;x升级至mysql5&period;7后导入之前数据库date出错的解决方法！</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7l55j8.html">WPF中通过代码设置控件的坐标</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdo5e78.html">Spring AOP中pointcut expression表达式解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4llkj8.html">&lbrack;测试&rsqb; 试用Hadoop 2&period;2中的HDFS NFS</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeegnj9.html">JavaScript高阶函数的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/96onr4j9.html">iOS 8 Handoff 开发指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gem1x08.html">if&lpar;男深圳集体户口&amp;amp&semi;&amp;amp&semi;女非深圳户口&rpar;深圳准生证办理材料及流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkl0o08.html">第一个元素&amp;lt&semi;flout&amp;gt&semi;写了&comma;想在他的旁边加一个元素&period;IE6会出现缝隙&period;    不要用margin撑开&comma;要用flout</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo33m1q.html">man rsync翻译&lpar;rsync命令中文手册&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj0mr28.html">JAVA入门（1&period;JAVA平台应用  2&period;核心概念：JVM，JDK，JRE  3&period;搭建JAVA开发环境  4&period;学习JAVA的原则）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me4026q.html">Android开发小问题集</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1kdo2q.html">Django常见问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y55vg8.html">Winform Focus&lpar;&rpar;函数不起作用 解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7om65x8.html">转载：MySQL看这一篇就够了</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2ngm0q.html">PROC IMPORT 选项</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv22wl19.html">在&period;net core 中PetaPoco结合EntityFrameworkCore使用codefirst方法进行开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllo350q.html">白兔的刁难 IDFT</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4xedk9.html">Linux编程 3 &lpar;初识bash shell与man查看手册&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wmmm0q.html">Android悬浮窗及其拖动事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4dd5lq.html">Python对文件和文件路径的管理</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m8ze6yx8.html">IOS 通用颜色快速生成代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw4nrz8.html">Dapper学习 - Dapper&period;Rainbow&lpar;一&rpar; - Create</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8er3gmq.html">js无法对远程图片进行Base64转码</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlppo19.html">从C&num;到Objective-C，循序渐进学习苹果开发&lpar;1&rpar;--准备开发账号和开发环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy005x8.html">C&num;三种判断字符是否为汉字的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/4957njeq.html">C&num;利用浏览按钮获得文件路径和文件夹路径</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93gl7g8.html">Hack其实是一门好语言</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1wnnz9.html">viewpager和fragment预加载的解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1wo2z9.html">Scalaz（37）－ Free ：实践－DB Transaction free style</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q70vyk8.html">ThinkCMF-幻灯片制作</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
